# C 程序：使用按引用调用以循环顺序交换数字

> 原文： [https://www.programiz.com/c-programming/examples/swapping-cyclic-order](https://www.programiz.com/c-programming/examples/swapping-cyclic-order)

#### 在此示例中，使用按引用调用以循环顺序交换用户输入的三个数字。

要理解此示例，您应该了解以下 [C 编程](/c-programming "C tutorial")主题：

*   [C 指针](/c-programming/c-pointers)
*   [C 按引用进行调用：使用指针](/c-programming/c-pointer-functions)

* * *

## 按引用调用交换元素的程序

```c
#include <stdio.h>
void cyclicSwap(int *a, int *b, int *c);
int main() {
    int a, b, c;

    printf("Enter a, b and c respectively: ");
    scanf("%d %d %d", &a, &b, &c);

    printf("Value before swapping:\n");
    printf("a = %d \nb = %d \nc = %d\n", a, b, c);

    cyclicSwap(&a, &b, &c);

    printf("Value after swapping:\n");
    printf("a = %d \nb = %d \nc = %d", a, b, c);

    return 0;
}

void cyclicSwap(int *n1, int *n2, int *n3) {
    int temp;
    // swapping in cyclic order
    temp = *n2;
    *n2 = *n1;
    *n1 = *n3;
    *n3 = temp;
} 
```

**输出**

```c
Enter a, b and c respectively: 1
2
3
Value before swapping:
a = 1 
b = 2 
c = 3
Value after swapping:
a = 3 
b = 1 
c = 2 
```

在此，用户输入的三个数字分别存储在变量`a`，`b`和`c`中。 这些数字的地址将传递到`cyclicSwap()`函数。

```c
cyclicSwap(&a, &b, &c); 
```

在`cyclicSwap()`的函数定义中，我们已将这些地址分配给了指针。

```c
cyclicSwap(int *n1, int *n2, int *n3) {
    ...
} 
```

当`cyclicSwap()`内部的`n1`，`n2`和`n3`改变时，`a`，`b`和`main()`内部的`c`也被更改。

**注意**： `cyclicSwap()`函数未返回任何内容。