# C++ 程序：查找字符串的长度

> 原文： [https://www.programiz.com/cpp-programming/examples/string-length](https://www.programiz.com/cpp-programming/examples/string-length)

#### 在此示例中，您将学习计算字符串（字符串对象和 C 样式字符串）的长度（大小）。

要理解此示例，您应该了解以下 [C++ 编程](/cpp-programming "C++ tutorial")主题：

*   [C++ 字符串](/cpp-programming/strings)

* * *

您可以使用`size()`函数或`length()`函数获取字符串对象的长度。

`size()`和`length()`函数只是同义词，它们都做完全相同的事情。

* * *

## 示例：字符串对象的长度

```cpp
#include <iostream>
using namespace std;

int main()
{
    string str = "C++ Programming";

    // you can also use str.length()
    cout << "String Length = " << str.size();

    return 0;
}
```

**输出**

```cpp
String Length = 15
```

* * *

## 示例：C 样式字符串的长度

要获取 C 字符串的长度，可以使用`strlen()`函数。

```cpp
#include <iostream>
#include <cstring>
using namespace std;

int main()
{
    char str[] = "C++ Programming is awesome";

    // you can also use str.length()
    cout << "String Length = " << strlen(str);

    return 0;
}
```

**输出**

```cpp
String Length = 26
```