# Java 注释

> 原文： [https://www.programiz.com/java-programming/comments](https://www.programiz.com/java-programming/comments)

#### 在本教程中，您将了解 Java 注释，为什么使用它们以及如何以正确的方式使用注释。

在计算机编程中，注释是程序的一部分，Java 编译器完全忽略了注释。 它们主要用于帮助程序员理解代码。 例如，

```java
// declare and initialize two variables
int a =1;
int b = 3;

// print the output
System.out.println("This is output"); 
```

在这里，我们使用了以下注释：

*   声明并初始化两个变量
*   打印输出

* * *

## Java 中的注释类型

在 Java 中，有两种类型的注释：

*   单行注释
*   多行注释

* * *

### 单行注释

单行注释在同一行中开始和结束。 要编写单行注释，我们可以使用`//`符号。 例如，

```java
// "Hello, World!" program example

class Main {
    public static void main(String[] args) {    	
    {
        // prints "Hello, World!"
        System.out.println("Hello, World!");
    }
} 
```

**输出**：

```java
Hello, World! 
```

在这里，我们使用了两个单行注释：

*   `"Hello, World!" program example`
*   `prints "Hello, World!"`

Java 编译器忽略从`//`到行尾的所有内容。 因此，它也被称为**行尾**注释。

* * *

### 多行注释

当我们想写多行注释时，可以使用多行注释。 要写多行注释，我们可以使用`/*....*/`符号。 例如，

```java
/* This is an example of  multi-line comment.
 * The program prints "Hello, World!" to the standard output.
 */

class HelloWorld {
    public static void main(String[] args) {    	
    {	
        System.out.println("Hello, World!");
    }
} 
```

**输出**：

```java
Hello, World! 
```

在这里，我们使用了多行注释：

```java
/* This is an example of multi-line comment.
* The program prints "Hello, World!" to the standard output.
*/ 
```

这种类型的注释也称为**传统注释**。 在这种类型的注释中，Java 编译器会忽略从`/*`到`*/`的所有内容。

* * *

## 正确使用注释

您应该始终考虑一件事，即注释不应该替代解释英文书写不好的代码的方法。 您应该始终编写结构合理且自我解释的代码。 然后，使用注释。

有些人认为代码应该是自描述的，注释应该很少使用。 但是，以我个人的观点，使用注释没有错。 我们可以使用注释来解释复杂的算法，正则表达式或需要在不同技术中选择一种技术来解决问题的方案。

**注意**：在大多数情况下，请始终使用注释来解释“**为什么做**”，而不是“**怎样做**”，您很高兴。