# Kotlin 程序：将字符转换为字符串并反之

> 原文： [https://www.programiz.com/kotlin-programming/examples/char-string](https://www.programiz.com/kotlin-programming/examples/char-string)

#### 在此程序中，您将学习在 Kotlin 中将字符（`char`）转换为字符串，反之亦然。

## 示例 1：将`char`转换为`String`

```kt
fun main(args: Array<String>) {
    val ch = 'c'
    val st = Character.toString(ch)
    // Alternatively
    // st = String.valueOf(ch);

    println("The string is: $st")
}
```

运行该程序时，输出为：

```kt
The string is: c
```

在上面的程序中，我们有一个字符存储在变量`ch`中。 我们使用`Character`类的`toString()`方法将字符转换为字符串`st`。

另外，我们也可以使用`String`的`valueOf()`方法进行转换。 但是，两者在内部是相同的。

* * *

## 示例 2：将`char`数组转换为`String`

如果您有一个`char`数组而不是一个`char`，我们可以使用`String`方法轻松地将其转换为`String`，如下所示：

```kt
fun main(args: Array<String>) {

    val ch = charArrayOf('a', 'e', 'i', 'o', 'u')

    val st = String(ch)
    val st2 = String(ch)

    println(st)
    println(st2)
}
```

运行该程序时，输出为：

```kt
aeiou
aeiou
```

在上面的程序中，我们有一个包含元音的 char 数组`ch`。 我们再次使用`String`的`valueOf()`方法将字符数组转换为`String`。

我们还可以使用`String`构造器，该构造器将字符数组`ch`作为转换参数。

* * *

## 示例 3：将字符串转换为字符数组

我们还可以使用`String`的`toCharArray()`方法将字符串转换为`char`数组（但不能转换为`char`）。

```kt
import java.util.Arrays

fun main(args: Array<String>) {

    val st = "This is great"

    val chars = st.toCharArray()
    println(Arrays.toString(chars))
}
```

运行该程序时，输出为：

```kt
[T, h, i, s,  , i, s,  , g, r, e, a, t]
```

在以上程序中，我们在变量`st`中存储了一个字符串。 我们使用`String`的`toCharArray()`方法将字符串转换为存储在`chars`中的字符数组。

然后，我们使用`Arrays`的`toString()`方法以类似数组的形式打印`chars`的元素。

以下是等效的 Java 代码：[将`char`转换为字符串，反之亦然的 Java 程序](/java-programming/examples/char-string "Java program to convert char to string and vice-versa")