# Kotlin 表达式，语句和块

> 原文： [https://www.programiz.com/kotlin-programming/statement-expression](https://www.programiz.com/kotlin-programming/statement-expression)

#### 在本文中，您将了解 Kotlin 表达式，Kotlin 语句，表达式与语句之间的差异以及 Kotlin 块。

## Kotlin 表达式

表达式由计算为单个值的[变量](/kotlin-programming/variable-types "Kotlin Variables")，[运算符](/kotlin-programming/operators "Kotlin Operators")等组成。

让我们举个例子

```kt
val score: Int
score = 90 + 25
```

在此，`90 + 25`是返回`Int`值的表达式。

* * *

在 Kotlin 中，`if`是不同于 Java 的表达式（在 Java 中，`if`是一条语句）。 例如，

```kt
fun main(args: Array<String>) {

    val a = 12
    val b = 13
    val max: Int

    max = if (a > b) a else b
    println("$max")
}

```

在此，`if (a > b) a else b`是一个表达式。 然后在上述程序中将表达式的值分配给`max`变量。 访问此页面以了解有关表达式的更多信息。

* * *

## Kotlin 语句

语句是构成完整执行单元的所有内容。 例如，

```kt
val score = 90 + 25
```

在此，`90 + 25`是返回 115 的表达式，`val score = 9*5;`是语句。

表达式是语句的一部分。

一些例子：

```kt
println("Howdy")
```

```kt
var a = 5
++a
```

```kt
max = if (a > b) a else b
```

* * *

## Kotlin 块

块是用大括号`{ }`括起来的一组语句（零个或多个）。 例如，

```kt
fun main(args: Array<String>) {  // main function block
    val flag = true

    if (flag == true) {      // start of if block
        print("Hey ")
        print("jude!")
    }                        // end of if block
}                            // end of main function block
```

`if`分支块中有两个语句`print("Hey ")`和`print(" jude!")`。

```kt
print("Hey ")
print("jude!")
```

同样，`main()`函数也具有块体。

```kt
val flag = true

if (flag == true) {      // start of block
    print("Hey ")
    print("jude!")
}                        // end of block

```